-- Author: AraBubbles
-- Version 3.4

local WBRmain = ""
local frame = CreateFrame("Frame")

-- Party/raid announcement
local msgType = {
	["arena"] = "PARTY",
	["party"] = "PARTY",
	["raid"] = "RAID",
}

function WBRmsg()
	local inGroup = IsInGroup()
    local IsRaid = IsInRaid()
	local inInstance, instanceType = IsInInstance()
	local WBRType = ""

	if WBRSay==true then
		WBRType = "SAY"
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		WBRType = "INSTANCE_CHAT"
    elseif IsInRaid() then
        WBRType = "RAID"
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		WBRType = msgType[instanceType]
	end

	SendChatMessage(WBRMain, WBRType)
end

local function handler (msg)
	if msg == '' then
		WBRHelp()
	elseif msg == 'on' then
		WBR = true
		frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		print("WBR is: "..getWBRStatus(WBR))
	elseif msg == 'off' then
		WBR = false
		frame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		print("WBR is: "..getWBRStatus(WBR))
	elseif msg == 'say' then
		WBRSay = true
		print("WBR is announcing on "..CheckWBRStatus().." .")
	elseif msg == 'group' then
		WBRSay = false
		print("WBR is announcing on "..CheckWBRStatus().." .")
	elseif msg == 'status' then
		print("WBR is announcing through: "..CheckWBRStatus())
	end
end

-- slash comands

SlashCmdList["WBR"] = handler;
SLASH_WBR1 = "/WBR"

function WBRHelp()
	print("WBR is announcing through: "..CheckWBRStatus())
	print("To check the status: /WBR status")
	print("To turn on WBR: /WBR on")
	print("To silence WBR: /WBR off")
	print("To announce in say: /WBR say")
	print("To announce in group: /WBR group")
end

function getWBRStatus(cond)
	if cond==true then
		return "|cffff0000On|r"	
	else
		return "|cffff0000Not making announcements|r"
	end
end

function CheckWBRStatus()
	if WBRSay == false then
		return "|cffff0000Your group.|r"
	end
	return "|cffff0000Says|r"
end

-- Spells and IDs
local WBRSpells = {
	
 -- Non-combat Resurrection abilities
	[50769] = true, -- Druid - Revive
	[115178] = true, -- Monk - Resuscitate
	[7328] = true, -- Paladin - Redemption
	[2006] = true, -- Priest - Resurrection 
	[2008] = true, -- Shaman - Ancestral Spirit
 -- Defibrillate - engineers
	[7148] = true, -- Goblin Jumper Cables
	[18587] = true, -- Goblin Jumper Cables XL
	[40772] = true, -- Gnomish Army Knife
	[114943] = true, -- Ultimate Gnomish Army Knife
 -- Combat Ressurection 
	[20484] = true, -- Druid - Rebirth
	[61999] = true, -- Deth Knight - Raise Ally
	[126393] = true, -- Hunter - Quilen pet - Eternal Guardian
	[159931] = true, -- Hunter - Crane pet - Gift of Chi-ji
	[159956] = true, -- Hunter - Moth Pet - Dust of Life
	[20707] = true, -- Warlock - Soulstone
 -- Self-Resurrestion
	[20608] = true, -- Shaman - Reincarnation
	[231811] = true, -- Warlock - Soulstone user
 -- Mass Resurrection 
	[212040] = true, -- Druid - Revitalize
	[212051] = true, -- Monk - Reawaken
	[212056] = true, -- Paladin - Absolution
	[212036] = true, -- Priest - Mass Resurrection
	[212048] = true, -- Shaman - Ancestral Vision
}

frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("PLAYER_LOGIN")

frame:SetScript("OnEvent", function(self, event, ...)
	if event == "ADDON_LOADED" then
		if WBR == nil then
			WBR = true
		end
		
		if WBRSay == nil then
			WBRSay = false
		end
		
		if WBR == true then
			frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		else
			frame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		end

	else
		local _, event, _, _, sourceName, _, _, _, _, _, _, spellID, spellName = ...		
		if (WBR == true and (UnitInParty(sourceName) or UnitInRaid(sourceName)) and (event=="SPELL_CAST_SUCCESS") and GetNumGroupMembers()>0 and WBRSpells[spellID]
		) then
			if WBRSpells[spellID] then
				WBRMain = "Who used Brez: "..sourceName.." cast "..GetSpellLink(spellID).."!!!"
			end
			
			WBRmsg(WBRMain)
		end
	end
end)